#include "drive.h"
#include "panic.h"
#include "fat.h"

uint8_t n_drives = 0;
struct drive drives[256];

__attribute__ ((const))
static drive_file_id_t unknown_get_file(const struct drive *d, const char *path) {
  return 0;
}

static void unknown_free_file(const struct drive *d, drive_file_id_t fid) {
  panic("Free file called on unknown file system");
}

static void unknown_load_sector(const struct drive *d, drive_file_id_t fid, uint32_t sector, void *at) {
  panic("Load sector called on unknown file system");
}

static uint32_t unknown_get_file_length(const struct drive *d, drive_file_id_t fid) {
  panic("Get file length called on unknown file system");
}

__attribute__ ((const))
static uint32_t unknown_get_free_sectors(const struct drive *d) {
  return -1;
}

__attribute__ ((const))
static uint32_t unknown_enumerate_dir(const struct drive *d, const char *path, struct directory_content_info *info, uint32_t max) {
  return 0;
}

static void determine_fs(struct drive *d) {
  if (try_fat_init_drive(d))
    return;

  d->fs_type = "Unknown";
  d->get_file = &unknown_get_file;
  d->free_file = &unknown_free_file;
  d->load_sector = &unknown_load_sector;
  d->get_file_length = &unknown_get_file_length;
  d->enumerate_dir = &unknown_enumerate_dir;
  d->get_free_sectors = &unknown_get_free_sectors;
}

void commit_drive(struct drive data) {
  determine_fs(&data);
  drives[n_drives++] = data;
}